package com.zt.plat.module.qms.business.config.dal.mapper;

import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.framework.mybatis.core.query.LambdaQueryWrapperX;
import com.zt.plat.framework.mybatis.core.query.MPJLambdaWrapperX;
import com.zt.plat.framework.mybatis.core.mapper.BaseMapperX;
import com.zt.plat.module.qms.business.config.controller.vo.ConfigProjectPageReqVO;
import com.zt.plat.module.qms.business.config.dal.dataobject.ConfigAssayMethodProjectDO;
import com.zt.plat.module.qms.business.config.dal.dataobject.ConfigProjectDO;
import com.zt.plat.module.qms.business.dic.dal.dataobject.DictionaryProjectDO;

import java.util.List;

import org.apache.ibatis.annotations.Mapper;
import com.zt.plat.module.qms.business.config.controller.vo.*;

/**
 * 检测项目配置 Mapper
 *
 * @author 后台管理
 */
@Mapper
public interface ConfigProjectMapper extends BaseMapperX<ConfigProjectDO> {

    default PageResult<ConfigProjectDO> selectPage(ConfigProjectPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<ConfigProjectDO>()
                .eqIfPresent(ConfigProjectDO::getDictionaryProjectId, reqVO.getDictionaryProjectId())
                .eqIfPresent(ConfigProjectDO::getConfigAssayMethodId, reqVO.getConfigAssayMethodId())
                .eqIfPresent(ConfigProjectDO::getSaveColumn, reqVO.getSaveColumn())
                .eqIfPresent(ConfigProjectDO::getSystemDepartmentCode, reqVO.getSystemDepartmentCode())
                .betweenIfPresent(ConfigProjectDO::getCreateTime, reqVO.getCreateTime())
                .eqIfPresent(ConfigProjectDO::getRemark, reqVO.getRemark())
                .orderByDesc(ConfigProjectDO::getId));
    }

    /**
     * 根据检测方法查询检测项目
     * @param configAssayMethodId
     * @return
     */
    default List<ConfigProjectExtendRespVO> selectByConfigAssayMethodId(Long configAssayMethodId) {
    	return selectJoinList(ConfigProjectExtendRespVO.class, new MPJLambdaWrapperX<ConfigProjectDO>()
    			.leftJoin(ConfigAssayMethodProjectDO.class, on -> on.eq(ConfigAssayMethodProjectDO::getConfigAssayMethodId, ConfigProjectDO::getConfigAssayMethodId).eq(ConfigAssayMethodProjectDO::getDictionaryProjectId, ConfigProjectDO::getDictionaryProjectId))
    			.leftJoin(DictionaryProjectDO.class, DictionaryProjectDO::getId, ConfigProjectDO::getDictionaryProjectId)
    			.selectAll(ConfigProjectDO.class)
    			.selectAs(ConfigAssayMethodProjectDO::getId, ConfigProjectExtendRespVO::getConfigAssayMethodProjectId)
    			.selectAs(ConfigAssayMethodProjectDO::getDictionaryProjectUnit, ConfigProjectExtendRespVO::getDictionaryProjectUnit)
    			.selectAs(DictionaryProjectDO::getKey, ConfigProjectExtendRespVO::getDictionaryProjectKey)
    			.selectAs(DictionaryProjectDO::getSimpleName, ConfigProjectExtendRespVO::getDictionaryProjectSimpleName)
    			.selectAs(DictionaryProjectDO::getShowName, ConfigProjectExtendRespVO::getDictionaryProjectShowName)
    			.eq(ConfigProjectDO::getConfigAssayMethodId, configAssayMethodId));
    }
}